.586
.model flat, stdcall
option casemap:none
include windows.inc
include kernel32.inc
includelib kernel32.lib
include user32.inc
includelib user32.lib

;***************************************************************************************************

.const
AppName     db "Peep",0
cmdline     db "cmd.exe",0
blargh      db "dir",13,10  ;--pass a command to cmd.exe as user input, end each with a newline
                            ;  add {"exit",13,10} to the end to close the cmd window afterward

.data?
startinfo   STARTUPINFO <?>
procinfo    PROCESS_INFORMATION <?>
secAttr     SECURITY_ATTRIBUTES <?>

pipeStdInR  HANDLE ?
pipeStdInW  HANDLE ?

nIOBytes    DWORD ?

.code
start:
    push edi
    mov edi,OFFSET secAttr
    assume edi:ptr SECURITY_ATTRIBUTES
    mov [edi].nLength,SIZEOF secAttr
    mov [edi].lpSecurityDescriptor,NULL
    mov [edi].bInheritHandle,TRUE

    invoke CreatePipe, ADDR pipeStdInR,ADDR pipeStdInW,ADDR secAttr,0

    mov edi,OFFSET startinfo
    assume edi:ptr STARTUPINFO

    xor eax,eax
    mov [edi].cb,SIZEOF startinfo
    mov [edi].lpReserved,eax
    mov [edi].lpDesktop,eax
    mov [edi].lpTitle,eax
    mov [edi].dwFlags,STARTF_USESHOWWINDOW or STARTF_USESTDHANDLES
    mov [edi].wShowWindow,SW_SHOWDEFAULT  ;SW_HIDE
    mov [edi].cbReserved2,ax
    mov [edi].lpReserved2,eax

    mov eax,pipeStdInR
    mov [edi].hStdInput,eax
    invoke GetStdHandle, STD_OUTPUT_HANDLE
    mov [edi].hStdOutput,eax
    invoke GetStdHandle, STD_ERROR_HANDLE
    mov [edi].hStdError,eax

    invoke CreateProcess, NULL,ADDR cmdline,NULL,NULL,TRUE,NULL,NULL,NULL,edi,ADDR procinfo
    invoke CloseHandle, pipeStdInR

    invoke WriteFile, pipeStdInW,ADDR blargh,SIZEOF blargh,ADDR nIOBytes,NULL

    mov eax,[procinfo.hProcess]
    invoke WaitForSingleObject,eax,INFINITE

    invoke CloseHandle, pipeStdInW

    assume edi:nothing
    pop edi
    invoke ExitProcess, NULL
end start
